import { XMLElem } from "@/util/XmlElem";
import type { NamespaceTable } from "./NameSpaceTable";
import { UABaseNode, type UABaseNodeOptions } from "./UABaseNode";
import type { IAddressSpace } from "./IAddressSpace";

export class UAReferenceType extends UABaseNode{
    public isAbstract: boolean;

    constructor(options: UAReferenceTypeOptions) {
        super(options)
        Object.assign(this, options);  
        this.nodeClass="UAReferenceType";
        this.isAbstract=options.isAbstract||false;
    }

    static  fromXML(xmlRefType: any, addressSpace: IAddressSpace): UAReferenceType{
        const bn=super.fromXML(xmlRefType, addressSpace)
        return new UAReferenceType(bn as UABaseNodeOptions);
    }

    toXML(lnst:NamespaceTable, gnst:NamespaceTable): XMLElem {
        const elem=super.toXML(lnst, gnst);
        elem.name=this.nodeClass;
        elem.attr('IsAbstract', this.isAbstract);
        return elem;
    }
}

export interface UAReferenceTypeOptions extends UABaseNodeOptions{
    isAbstract?: boolean
}